# ifndef __UD_H_
# define __UD_H_

# include "types.h"

struct Defn {
	int      id;		/* The defn. id */
	SdgNode *node;		/* The sdg node corr. to this defn. */
	rtx      insn;		/* The instr. corr. to this defn */
	int      regNo;		/* The pseudo-reg corr. to this defn.  */
	int      bbId;     	/* Basic block which contains this defn */
};

extern int  numDefns;

extern void  InitDefns();
extern void  AddNewDefn(int bbId, int regno, rtx insn);
extern void  IdentifyDefnsInBB(int bbId);
extern Defn *GetDefn(int defnId);
extern void  FreeDefns();

# endif __UD_H_
